<?php

namespace MT\NFT\ImporterOpensea;

class API
{
    public function initEndpoints() {
        register_rest_route("nft-importer", '/get-settings', array(
            'methods' => 'GET',
            'callback' => [$this, 'isUserAdmin'],
            'permission_callback' => function ($request) {
                return is_user_logged_in();
            },
        ));

        register_rest_route("nft-importer", '/list-categories', array(
            'methods' => 'GET',
            'callback' => [$this, 'listCategories'],
            'permission_callback' => function ($request) {
                return is_user_logged_in();
            },
        ));
    }

    public function isUserAdmin() {
//        return new \WP_REST_Response(array("payload" => user_can_access_admin_page()));
    }

    public function listCategories() {
        $orderby = 'name';
        $order = 'asc';
        $hide_empty = false ;
        $cat_args = array(
            'orderby'    => $orderby,
            'order'      => $order,
            'hide_empty' => $hide_empty,
        );

        return get_terms( 'product_cat', $cat_args );
    }
}
