<?php 
require('../../../wp-load.php');

set_time_limit(0);
ignore_user_abort( 1 );

$query = new WP_Query(
    array(
        'post_type' => 'product',
        'posts_per_page'=> -1,
        'meta_query' => array(
            'relation' => 'OR', //default AND
            array(
                'key' => '_mtnft_tokenID',
                'compare' => 'EXISTS'
            ),
            array(
                'key' => '_mtnft_tokenID',
                'value' => '0',
                'compare' => '>'
            )
        )
    )
);

require "./api-helper.class.php";

$helper = new Mtnft_API_Helper();

$nftsPerBatch = 25;
$postCount = $query->found_posts;
$rest = $postCount % 10;
$batchSize = ($postCount - $rest) / $nftsPerBatch + ($rest === 0 ? 0 : 1);
$posts = $query->get_posts();

for($b = 1; $b <= $batchSize; $b++) {
    $queryList = [];
    $updateAtOnce= $b * $nftsPerBatch;
    $diff = $nftsPerBatch;
    if ($b > 0) {
        sleep(1);
    }
    if($rest !== 0 && $b === $batchSize) {
        $updateAtOnce=  ($b - 1)* $nftsPerBatch  + $rest;
        $diff = $rest;
    }

    for($i = $updateAtOnce - $diff; $i < $updateAtOnce; $i++) {
        $array = [];
        $product = $posts[$i];
        $currentTokenId = get_post_meta($product->ID,'_mtnft_tokenID', true);
        $currentAddress = get_post_meta($product->ID,'_mtnft_address', true);
        if($currentTokenId && 
        $currentAddress && 
        $currentTokenId !== '' && 
        $currentAddress !== '') {
            $array['token_ids'] = $currentTokenId;
            $array['asset_contract_addresses'] =  $currentAddress;
            $queryList[] = $array;
        } else {
            $tokenAndAddress =  explode('/',str_replace('https://opensea.io/assets/', '',get_post_meta($product->ID,'_product_url', true)));
            $array['token_ids'] = $tokenAndAddress[1];
            $array['asset_contract_addresses'] = $tokenAndAddress[0];
            $queryList[] = $array;
        }
    }

    $url = preg_replace('(%5D)', '', preg_replace('(\d+%5B)', '',http_build_query($queryList)));

    $curl = curl_init();

    curl_setopt_array($curl, [
        CURLOPT_URL => "https://api.opensea.io/api/v1/assets?order_direction=desc&$url",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 6000,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_2_0,
        CURLOPT_CUSTOMREQUEST => "GET",
        CURLOPT_HTTPHEADER => [
            "Accept: application/json"
        ],
        CURLOPT_USERAGENT =>  'Mozilla/5.0 (Windows NT 6.2; WOW64; rv:17.0) Gecko/20100101 Firefox/17.0',
        CURLOPT_REFERER => "https://example.com/"
    ]);

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    $key = lcfirst(implode('', array_map('ucfirst', explode('_',$response ))));
    echo $helper->update_price_batch(json_decode($key, true)['assets']);
}